### Home Classes Methods

### In Files

- lib/ffi/managedstruct.rb

### Parent

FFI::Struct

### Methods

- ::new

### Files

- Makefile
- ChangeLog
- LICENSE
- README
- compile
- configure
- depcomp
- stamp-vti
- install-sh
- libtool-version
- mdate-sh
- missing

### Class/Module Index

Quicksearch

- FFI
- FFI::AutoPointer
- FFI::AutoPointer::CallableReleaser
- FFI::AutoPointer::DefaultReleaser
- FFI::AutoPointer::Releaser
- FFI::ConstGenerator
- FFI::ConstGenerator::Constant
- FFI::Enum
- FFI::Enums
- FFI::FunctionType
- FFI::Generator
- FFI::Generator::Task
- FFI::IO
- FFI::Library
- FFI::ManagedStruct
- FFI::NotFoundError
- FFI::Platform
- FFI::PlatformError
- FFI::Pointer
- FFI::StrPtrConverter
- FFI::Struct
- FFI::Struct::ManagedStructConverter
- FFI::StructGenerator
- FFI::StructGenerator::Field
- FFI::StructLayout
- FFI::StructLayout::Array
- FFI::StructLayout::Enum
- FFI::StructLayout::Field
- FFI::StructLayout::Function
- FFI::StructLayout::InnerStruct
- FFI::StructLayout::Mapped
- FFI::StructLayout::Number
- FFI::StructLayout::Pointer
- FFI::StructLayout::String
- FFI::StructLayoutBuilder
- FFI::TypesGenerator
- FFI::Union
- FFI::VariadicInvoker

No matching classes.

# FFI::ManagedStruct

FFI::ManagedStruct allows custom garbage-collection of your FFI::Structs.

The typical use case would be when interacting with a library that has a nontrivial memory management design, such as a linked list or a binary tree.

When the {Struct} instance is garbage collected, FFI::ManagedStruct will invoke the class's release() method during object finalization.

@example Example usage:

    module MyLibrary
      ffi_lib "libmylibrary"
      attach_function :new_dlist, [], :pointer
      attach_function :destroy_dlist, [:pointer], :void
    end

    class DoublyLinkedList < FFI::ManagedStruct
      @@@
      struct do |s|
        s.name 'struct dlist'
        s.include 'dlist.h'
        s.field :head, :pointer
        s.field :tail, :pointer
      end
      @@@

      def self.release ptr
        MyLibrary.destroy_dlist(ptr)
      end
    end

    begin
      ptr = DoublyLinkedList.new(MyLibrary.new_dlist)
      #  do something with the list
    end
    # struct is out of scope, and will be GC'd using DoublyLinkedList#release

### Public Class Methods

new(pointer=nil) click to toggle source

@overload initialize(pointer)

    @param [Pointer] pointer
    Create a new ManagedStruct which will invoke the class method #release on

@overload initialize A new instance of FFI::ManagedStruct.

    # File lib/ffi/managedstruct.rb, line 48
    def initialize(pointer=nil)
      raise NoMethodError, "release() not implemented for class #{self}" unless self.class.respond_to? :release
      raise ArgumentError, "Must supply a pointer to memory for the Struct" unless pointer
      super AutoPointer.new(pointer, self.class.method(:release))
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.